// #autoload
// #name = statusHud
// #version = 1.0
// #date = November 9, 2001
// #author = |C|-DEbig3
// #warrior =  DEbig3
// #email = debig3@qwest.net
// #web = http://scripts.tribalwar.com/debig3
// #description = displays a hud showing current fps, max fps, average fps, ping, packetloss, speed, altitude
// #status = release

package statusHudPackage {
function NetBarHud::infoUpdate(%this, %ping, %packetLoss, %sendPackets, %sendBytes, %receivePackets, %receiveBytes) {
	parent::infoUpdate(%this, %ping, %packetLoss, %sendPackets, %sendBytes, %receivePackets, %receiveBytes);
	$statusHudPing = mFormatFloat(%ping, "%4.0f");
	$statusHudPL = mFormatFloat(%packetLoss, "%3.0f");
}

function statusHudBuild() {
	if (isObject(statusHudHud)) {
		statusHudHud.delete();
	}
	%y = getWord(outerChatHud.position, 1);
	%x = getWord(outerChatHud.position, 0) + getWord(outerChatHud.extent, 0) + 3;
	%pos = %x @ " " @ %y;
	$statusHud = new ShellFieldCtrl(statusHudHud) {
			profile = "GuiChatBackProfile";
			horizSizing = "left";
			vertSizing = "top";
			position = %pos;
			extent = "153 34";
			minExtent = "2 2";
			visible = "1";
	};
	playgui.add($statusHud);
	new GuiControlProfile ("statusHudTagProfile")
	{
		fontType = "Univers Condensed";
		fontSize = 14;
		fontColor = "200 200 200";
		justify = "center";
	};
	new GuiControlProfile ("statusHudTextProfile")
	{
		fontType = "Univers Condensed";
		fontSize = 14;
		justify = "center";
	};
	statusHudHud.fpscurrenttext = new GuiMLTextCtrl() {
			profile = "statusHudTagProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "4 0";
			extent = "20 16";
			visible = "1";
			text = "fps:";
	};
	statusHudHud.fpscurrent = new GuiMLTextCtrl() {
			profile = "statusHudTextProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "24 0";
			extent = "25 16";
			visible = "1";
			text = "0";
	};
	statusHudHud.fpsaveragetext = new GuiMLTextCtrl() {
			profile = "statusHudTagProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "53 0";
			extent = "20 16";
			visible = "1";
			text = "avg:";
	};
	statusHudHud.fpsaverage = new GuiMLTextCtrl() {
			profile = "statusHudTextProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "73 0";
			extent = "25 16";
			visible = "1";
			text = "0";
	};
	statusHudHud.fpsmaxtext = new GuiMLTextCtrl() {
			profile = "statusHudTagProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "100 0";
			extent = "20 16";
			visible = "1";
			text = "max:";
	};
	statusHudHud.fpsmax = new GuiMLTextCtrl() {
			profile = "statusHudTextProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "120 0";
			extent = "25 16";
			visible = "1";
			text = "0";
	};
	statusHudHud.pingtext = new GuiMLTextCtrl() {
			profile = "statusHudTagProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "4 16";
			extent = "20 16";
			visible = "1";
			text = "ping:";
	};
	statusHudHud.ping = new GuiMLTextCtrl() {
			profile = "statusHudTextProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "22 16";
			extent = "20 16";
			visible = "1";
			text = $statusHudPing;
	};
	statusHudHud.pltext = new GuiMLTextCtrl() {
			profile = "statusHudTagProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "47 16";
			extent = "15 16";
			visible = "1";
			text = "pl:";
	};
	statusHudHud.pl = new GuiMLTextCtrl() {
			profile = "statusHudTextProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "57 16";
			extent = "20 16";
			visible = "1";
			text = $statusHudPL;
	};
	statusHudHud.speedtext = new GuiMLTextCtrl() {
			profile = "statusHudTagProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "73 16";
			extent = "28 16";
			visible = "1";
			text = "speed:";
	};
	statusHudHud.speed = new GuiMLTextCtrl() {
			profile = "statusHudTextProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "101 16";
			extent = "24 16";
			visible = "1";
			text = "0";
	};
	statusHudHud.altitudetext = new GuiMLTextCtrl() {
			profile = "statusHudTagProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "120 16";
			extent = "15 16";
			visible = "1";
			text = "alt:";
	};
	statusHudHud.altitude = new GuiMLTextCtrl() {
			profile = "statusHudTextProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "133 16";
			extent = "20 16";
			visible = "1";
			text = "0";
	};
	statusHudHud.add(statusHudHud.fpscurrenttext);
	statusHudHud.fpscurrenttext.setText("fps:");
	statusHudHud.add(statusHudHud.fpscurrent);
	statusHudHud.add(statusHudHud.fpsaveragetext);
	statusHudHud.fpsaveragetext.setText("avg:");
	statusHudHud.add(statusHudHud.fpsaverage);
	statusHudHud.add(statusHudHud.fpsmaxtext);
	statusHudHud.fpsmaxtext.setText("max:");
	statusHudHud.add(statusHudHud.fpsmax);
	statusHudHud.add(statusHudHud.pingtext);
	statusHudHud.pingtext.setText("ping:");
	statusHudHud.add(statusHudHud.ping);
	statusHudHud.add(statusHudHud.pltext);
	statusHudHud.pltext.setText("pl:");
	statusHudHud.add(statusHudHud.pl);
	statusHudHud.add(statusHudHud.speedtext);
	statusHudHud.speedtext.setText("speed:");
	statusHudHud.add(statusHudHud.speed);
	statusHudHud.add(statusHudHud.altitudetext);
	statusHudHud.altitudetext.setText("alt:");
	statusHudHud.add(statusHudHud.altitude);
	if(isObject(HM) && isObject(HudMover)) {
		hudmover::addhud(statusHudHud, "statusHud");
	}
}

function statusHudSetPosition() {
	%y = getWord(outerChatHud.position, 1);
	%x = getWord(outerChatHud.position, 0) + getWord(outerChatHud.extent, 0) + 3;
	%pos = %x @ " " @ %y;
	statusHudHud.position = %pos;
	if ($hudposstatusHudHud !$= "") {
		statusHudHud.position = $hudposstatusHudHud;
	}
}

function playGui::onWake(%this) {
	parent::onWake(%this);
	statusHudUpdate();
	schedule(1000, 0, statusHudSetPosition);
}

function statusHudUpdate() {
	cancel($statusHudSchedule);
	%speed = mFloor(getControlObjectSpeed() * 3.6);
	%alt = getControlObjectAltitude();
	%fps = $fps::real;
	if (%fps > $statusHudStats::maxfps) {
		$statusHudStats::maxfps = %fps;
	}
	%x = strstr($statusHudStats::avgfps, ".");
	%avgfps = getSubStr($statusHudStats::avgfps, 0, %x + 2);
	$statusHudStats::fpscount++;
	$statusHudStats::totalfps += %fps;
	$statusHudStats::avgfps = $statusHudStats::totalfps / $statusHudStats::fpscount;
	statusHudHud.fpscurrent.setText(%fps);
	statusHudHud.fpsaverage.setText(%avgfps);
	statusHudHud.fpsmax.setText($statusHudStats::maxfps);
	statusHudHud.ping.setText($statusHudPing);
	statusHudHud.pl.setText($statusHudPL);
	statusHudHud.speed.setText(%speed);
	statusHudHud.altitude.setText(%alt);
	$statusHudSchedule = schedule(1000, 0, statusHudUpdate);
}

function statusHudToggle(%val) {
if (%val) {
	$statusHudToggle = !$statusHudToggle;
	statusHudHud.setVisible($statusHudToggle);
}
}

function OptionsDlg::onWake(%this) {
	if(!$statusHudBind) {
		$RemapName[$RemapCount]="statusHud Toggle";
		$RemapCmd[$RemapCount]="statusHudToggle";
		$RemapCount++;
		$statusHudBind = true;
	}
	parent::onWake(%this);
}

function DispatchLaunchMode() {
	parent::DispatchLaunchMode();
	statusHudBuild();
}
};

$statusHudBind = false;
$statusHudToggle = true;
activatePackage(statusHudPackage);
	
	
